//
//  TutorialsController.h
//  Terraray
//
//  Created by Mendel Kucharzeck on 18.11.11.
//  Copyright 2011 AvisNocturna Software. All rights reserved.
//


@protocol ANTutorialsControllerDelegate

- (void) tutorialsHaveBeenUpdated;
- (void) tutorialsUpdateFailed;

@end

@interface ANTutorialsController : NSObject <NSConnectionDelegate>
{
    NSArray *availableTutorialDictionaries;
    
    NSMutableArray *delegates;
    
    //Query Connection
    NSURLConnection *queryConnection;
    NSMutableData *queryConnectionData;
}

+ (ANTutorialsController*) sharedTutorialsController;
- (void) startQueryTutorialsForApp:(NSString*)app;

- (void) addDelegate:(id <ANTutorialsControllerDelegate>)d;
- (void) removeDelegate:(id)d;

- (BOOL) isUpToDate;

- (NSMenu*) tutorialsMenuIncludingTopLevelItem:(BOOL)topLevelItem;

@end
